unit GraphMin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, DateUtils, StdCtrls;

type
  TFGraphMin = class(TForm)
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TFastLineSeries;
    Label_1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    FTimePoint: TTIme;
    FAbove : boolean;
    FNumOfEntries: integer;
    fcounter :Integer;
  public
    procedure RealTimeAdd(Series: TChartSeries; Val : Double);
    procedure RealTimeAdd2(Series: TChartSeries);
    procedure DoScrollPoints(Series: TChartSeries);
    procedure AdjustView(Series: TChartSeries);
  end;
const
  NUM_OF_SEC_T0_VEIW = 60;
//var
//  FGraphMin: TFGraphMin;

implementation

{$R *.dfm}

procedure TFGraphMin.AdjustView(Series: TChartSeries);
begin
   Series.GetHorizAxis.SetMinMax(IncSecond(now, -NUM_OF_SEC_T0_VEIW), now);
end;

procedure TFGraphMin.DoScrollPoints(Series: TChartSeries);
begin
  if Series.XValues.Count > 0 then begin
    while Series.XValues.First < IncSecond(now, -NUM_OF_SEC_T0_VEIW) do begin
      Series.Delete(0);
    end;
  end;


   AdjustView(Series);
end;

procedure TFGraphMin.FormCreate(Sender: TObject);
var
   Above : Boolean;
   I: Integer;
begin


   FNumOfEntries := 0;
  fcounter := 0;
  FTimePoint := Now;
  Chart1.Title.Visible              := false;
  Chart1.Legend.Visible             := false;

  Chart1.BottomAxis.RoundFirstLabel := false;
  Chart1.View3D                     := False;

  Chart1.BottomAxis.DateTimeFormat  := 'hh:MM:ss';
  Series1.XValues.DateTime          := true;
  Series2.XValues.DateTime          := true;
  Chart1.BottomAxis.Increment       := IncSecond(0, NUM_OF_SEC_T0_VEIW div 6);

  Chart1.LeftAxis.Increment         := 10;
  Chart1.LeftAxis.AxisValuesFormat  := '0%';
  Chart1.Zoom.Allow                 := false;
  Chart1.AllowPanning               := pmNone;
  Chart1.BufferedDisplay            := True;
  Series1.AutoRepaint               := true;
  Series1.XValues.Order             := loNone;
  Series2.AutoRepaint               := true;
  Series2.XValues.Order             := loNone;
  Chart1.Axes.FastCalc              := True;

  Chart1.LeftAxis.SetMinMax(0, 100);

    Chart1.BottomAxis.SetMinMax(IncSecond(now, - NUM_OF_SEC_T0_VEIW), now);
  Above := False;
  for I := 0 to 60 do
  begin
     if (I mod 10) = 0 then
     begin
       Above := Above = false;
     end;
     if Above then
        Series2.AddXY(IncSecond(now, 0 - I),100)
     else
        Series2.AddXY(IncSecond(now, 0 - I),0)


  end;

  DoScrollPoints(Series2);
end;

procedure TFGraphMin.RealTimeAdd(Series: TChartSeries; Val: Double);
var
  XValue,YValue, XValue2,YValue2 : Double;
  CurrentIndex: integer;
begin
  if Series.Count = 0 then begin
    YValue := 0;
    XValue := now;
  end
  else
  begin

    YValue := Val;
    XValue := now;
  end;


  CurrentIndex := Series.AddXY(XValue,YValue);

  inc(FNumOfEntries);
end;

procedure TFGraphMin.RealTimeAdd2(Series: TChartSeries);
var
  XValue,YValue, XValue2,YValue2 : Double;
  CurrentIndex: integer;

begin
  if Series.Count = 0 then
  begin
    YValue := 0;
    XValue := now;
    Series2.AddXY(XValue,YValue)
  end
  else
  begin

      FTimePoint := IncSecond(FTimePoint, 1);
     if (fcounter mod 10) = 0 then
     begin
       FAbove := FAbove = false;

     end;
     if FAbove then
        Series2.AddXY(IncSecond(FTimePoint,-1),0)
     else
         Series2.AddXY(IncSecond(FTimePoint, -1),100);
       Inc(fcounter);

     if SecondsBetween(Now, FTimePoint) > 1 then
     begin

          FTimePoint := now;

     end;

     if fcounter = 20 then
        fcounter := 10;
  end;


  inc(FNumOfEntries);

end;

end.
