unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CPU_USage, HDD_Usage, uSMBIOS, TypInfo, Math, TeEngine,
  Series, TeeProcs, Chart, DateUtils,  Buttons, jpeg, ImgList, GraphMin;




type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Notebook1: TNotebook;
    Panel_CPU: TPanel;
    Panel_HDD: TPanel;
    Label_ProcName: TLabel;
    Panel1: TPanel;
    Panel_BtnHDD: TPanel;
    Image2: TImage;
    Panel_BtnCPU: TPanel;
    Image1: TImage;
    Label_TotalCPU: TLabel;
    Label_TotalHDD: TLabel;
    Labe_HDD: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Panel_BtnCPUClick(Sender: TObject);
    procedure Panel_BtnHDDClick(Sender: TObject);
    procedure Panel_BtnHDDMouseEnter(Sender: TObject);
    procedure Panel_BtnHDDMouseLeave(Sender: TObject);
    procedure Panel_BtnCPUMouseEnter(Sender: TObject);
    procedure Panel_BtnCPUMouseLeave(Sender: TObject);
  private
    procedure CPUUsageEvent(CPUUsage: TCPUUsage);
    procedure HDDUsageEvent(Usage: double);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CPUReport : TCPUReport;
  HDDReport: THDDReport;
  SMBios             : TSMBios;
  LProcessorInfo     : TProcessorInformation;
  LSRAMTypes         : TCacheSRAMTypes;
  FGraphTotalCPU: TFGraphMin;
  FGraphCPU_0: TFGraphMin;
  FGraphCPU_1: TFGraphMin;
  FGraphCPU_2: TFGraphMin;
  FGraphCPU_3: TFGraphMin;

  FGraphCPU_4: TFGraphMin;
  FGraphCPU_5: TFGraphMin;
  FGraphCPU_6: TFGraphMin;
  FGraphCPU_7: TFGraphMin;

  FGraphCPU_8: TFGraphMin;
  FGraphCPU_9: TFGraphMin;
  FGraphCPU_10: TFGraphMin;
  FGraphCPU_11: TFGraphMin;

  FGraphCPU_12: TFGraphMin;
  FGraphCPU_13: TFGraphMin;
  FGraphCPU_14: TFGraphMin;
  FGraphCPU_15: TFGraphMin;

  FGraphTotalHDD: TFGraphMin;


implementation

{$R *.dfm}

function SetToString(Info: PTypeInfo; const Value): String;
var
  LTypeInfo  : PTypeInfo;
  LIntegerSet: TIntegerSet;
  I: Integer;
 
begin
  Result := '';
 
    Integer(LIntegerSet) := 0;
    case GetTypeData(Info)^.OrdType of
      otSByte, otUByte: Integer(LIntegerSet)  := Byte(Value);
      otSWord, otUWord: Integer(LIntegerSet)  := Word(Value);
      otSLong, otULong: Integer(LIntegerSet)  := Integer(Value);
    end;
 
  LTypeInfo  := GetTypeData(Info)^.CompType{$IFNDEF FPC}^{$ENDIF};
  for I := 0 to SizeOf(Integer) * 8 - 1 do
    if I in LIntegerSet then
    begin
      if Result <> '' then Result := Result + ',';
      Result := Result + GetEnumName(LTypeInfo, I);
    end;
end;

{procedure TForm1.GetProcessorInfo;
Var
  SMBios             : TSMBios;
  LProcessorInfo     : TProcessorInformation;
  LSRAMTypes         : TCacheSRAMTypes;
begin
  SMBios:=TSMBios.Create;
  try
      Memo1.Lines.Add('Processor Information');
      if SMBios.HasProcessorInfo then
      for LProcessorInfo in SMBios.ProcessorInfo do
      begin
        Memo1.Lines.Add('Manufacturer       '+LProcessorInfo.ProcessorManufacturerStr);
        Memo1.Lines.Add('Socket Designation '+LProcessorInfo.SocketDesignationStr);
        Memo1.Lines.Add('Type               '+LProcessorInfo.ProcessorTypeStr);
        Memo1.Lines.Add('Familiy            '+LProcessorInfo.ProcessorFamilyStr);
        Memo1.Lines.Add('Version            '+LProcessorInfo.ProcessorVersionStr);
        Memo1.Lines.Add(Format('Processor ID       %x',[LProcessorInfo.RAWProcessorInformation^.ProcessorID]));
        Memo1.Lines.Add(Format('Voltage            %n',[LProcessorInfo.GetProcessorVoltage]));
        Memo1.Lines.Add(Format('External Clock     %d  Mhz',[LProcessorInfo.RAWProcessorInformation^.ExternalClock]));
        Memo1.Lines.Add(Format('Maximum processor speed %d  Mhz',[LProcessorInfo.RAWProcessorInformation^.MaxSpeed]));
        Memo1.Lines.Add(Format('Current processor speed %d  Mhz',[LProcessorInfo.RAWProcessorInformation^.CurrentSpeed]));
        Memo1.Lines.Add('Processor Upgrade   '+LProcessorInfo.ProcessorUpgradeStr);
        Memo1.Lines.Add(Format('External Clock     %d  Mhz',[LProcessorInfo.RAWProcessorInformation^.ExternalClock]));
        Memo1.Lines.Add('__________________________________');
        if SMBios.SmbiosVersion>='2.3' then
        begin
          Memo1.Lines.Add('Serial Number      '+LProcessorInfo.SerialNumberStr);
          Memo1.Lines.Add('Asset Tag          '+LProcessorInfo.AssetTagStr);
          Memo1.Lines.Add('Part Number        '+LProcessorInfo.PartNumberStr);
          if SMBios.SmbiosVersion>='2.5' then
          begin
            Memo1.Lines.Add(Format('Core Count         %d',[LProcessorInfo.RAWProcessorInformation^.CoreCount]));
            Memo1.Lines.Add(Format('Cores Enabled      %d',[LProcessorInfo.RAWProcessorInformation^.CoreEnabled]));
            Memo1.Lines.Add(Format('Threads Count      %d',[LProcessorInfo.RAWProcessorInformation^.ThreadCount]));
            Memo1.Lines.Add(Format('Processor Characteristics %.4x',[LProcessorInfo.RAWProcessorInformation^.ProcessorCharacteristics]));
          end;
        end;
//        Writeln;
         Memo1.Lines.Add('__________________________________');
        if (LProcessorInfo.RAWProcessorInformation^.L1CacheHandle>0) and (LProcessorInfo.L2Chache<>nil)  then
        begin
          Memo1.Lines.Add('L1 Cache Handle Info');
          Memo1.Lines.Add('--------------------');
          Memo1.Lines.Add('  Socket Designation    '+LProcessorInfo.L1Chache.SocketDesignationStr);
          Memo1.Lines.Add(Format('  Cache Configuration   %.4x',[LProcessorInfo.L1Chache.RAWCacheInformation^.CacheConfiguration]));
          Memo1.Lines.Add(Format('  Maximum Cache Size    %d Kb',[LProcessorInfo.L1Chache.GetMaximumCacheSize]));
          Memo1.Lines.Add(Format('  Installed Cache Size  %d Kb',[LProcessorInfo.L1Chache.GetInstalledCacheSize]));
          LSRAMTypes:=LProcessorInfo.L1Chache.GetSupportedSRAMType;
          Memo1.Lines.Add(Format('  Supported SRAM Type   [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
          LSRAMTypes:=LProcessorInfo.L1Chache.GetCurrentSRAMType;
          Memo1.Lines.Add(Format('  Current SRAM Type     [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
 
          Memo1.Lines.Add(Format('  Error Correction Type %s',[ErrorCorrectionTypeStr[LProcessorInfo.L1Chache.GetErrorCorrectionType]]));
          Memo1.Lines.Add(Format('  System Cache Type     %s',[SystemCacheTypeStr[LProcessorInfo.L1Chache.GetSystemCacheType]]));
          Memo1.Lines.Add(Format('  Associativity         %s',[LProcessorInfo.L1Chache.AssociativityStr]));
        end;
        Memo1.Lines.Add('__________________________________');
        if (LProcessorInfo.RAWProcessorInformation^.L2CacheHandle>0)  and (LProcessorInfo.L2Chache<>nil)  then
        begin
          Memo1.Lines.Add('L2 Cache Handle Info');
          Memo1.Lines.Add('--------------------');
          Memo1.Lines.Add('  Socket Designation    '+LProcessorInfo.L2Chache.SocketDesignationStr);
          Memo1.Lines.Add(Format('  Cache Configuration   %.4x',[LProcessorInfo.L2Chache.RAWCacheInformation^.CacheConfiguration]));
          Memo1.Lines.Add(Format('  Maximum Cache Size    %d Kb',[LProcessorInfo.L2Chache.GetMaximumCacheSize]));
          Memo1.Lines.Add(Format('  Installed Cache Size  %d Kb',[LProcessorInfo.L2Chache.GetInstalledCacheSize]));
          LSRAMTypes:=LProcessorInfo.L2Chache.GetSupportedSRAMType;
          Memo1.Lines.Add(Format('  Supported SRAM Type   [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
          LSRAMTypes:=LProcessorInfo.L2Chache.GetCurrentSRAMType;
          Memo1.Lines.Add(Format('  Current SRAM Type     [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
 
          Memo1.Lines.Add(Format('  Error Correction Type %s',[ErrorCorrectionTypeStr[LProcessorInfo.L2Chache.GetErrorCorrectionType]]));
          Memo1.Lines.Add(Format('  System Cache Type     %s',[SystemCacheTypeStr[LProcessorInfo.L2Chache.GetSystemCacheType]]));
          Memo1.Lines.Add(Format('  Associativity         %s',[LProcessorInfo.L2Chache.AssociativityStr]));
        end;
        Memo1.Lines.Add('__________________________________');
        if (LProcessorInfo.RAWProcessorInformation^.L3CacheHandle>0) and (LProcessorInfo.L3Chache<>nil) then
        begin
          Memo1.Lines.Add('L3 Cache Handle Info');
          Memo1.Lines.Add('--------------------');
          Memo1.Lines.Add('  Socket Designation    '+LProcessorInfo.L3Chache.SocketDesignationStr);
          Memo1.Lines.Add(Format('  Cache Configuration   %.4x',[LProcessorInfo.L3Chache.RAWCacheInformation^.CacheConfiguration]));
          Memo1.Lines.Add(Format('  Maximum Cache Size    %d Kb',[LProcessorInfo.L3Chache.GetMaximumCacheSize]));
          Memo1.Lines.Add(Format('  Installed Cache Size  %d Kb',[LProcessorInfo.L3Chache.GetInstalledCacheSize]));
          LSRAMTypes:=LProcessorInfo.L3Chache.GetSupportedSRAMType;
          Memo1.Lines.Add(Format('  Supported SRAM Type   [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
          LSRAMTypes:=LProcessorInfo.L3Chache.GetCurrentSRAMType;
          Memo1.Lines.Add(Format('  Current SRAM Type     [%s]',[SetToString(TypeInfo(TCacheSRAMTypes), LSRAMTypes)]));
 
          Memo1.Lines.Add(Format('  Error Correction Type %s',[ErrorCorrectionTypeStr[LProcessorInfo.L3Chache.GetErrorCorrectionType]]));
          Memo1.Lines.Add(Format('  System Cache Type     %s',[SystemCacheTypeStr[LProcessorInfo.L3Chache.GetSystemCacheType]]));
          Memo1.Lines.Add(Format('  Associativity         %s',[LProcessorInfo.L3Chache.AssociativityStr]));
        end;
 
      //  Readln;
      end
      else
     // Writeln('No Processor Info was found');
  finally
   SMBios.Free;
  end;
end;  }


function DriveSpace(DriveLetter : String; var FreeSpace, UsedSpace, TotalSpace : int64) : Boolean;
begin
  Result := SysUtils.GetDiskFreeSpaceEx(Pchar(DriveLetter), UsedSpace, TotalSpace, @FreeSpace);

  if UsedSpace > 0 then
    UsedSpace := TotalSpace - FreeSpace;

  if not Result then
  begin
    UsedSpace   := 0;
    TotalSpace  := 0;
    FreeSpace   := 0;
  end;
end;

procedure TForm1.HDDUsageEvent(Usage: double);
begin
      Label_TotalHDD.Caption :=  'Disk : ' +  IntToStr(Trunc(Usage)){FloatToStrF(CPUUsage.Total,ffFixed, 3, 2)} + '%';
      FGraphTotalHDD.RealTimeAdd2(FGraphTotalHDD. Series2);
      FGraphTotalHDD.DoScrollPoints(FGraphTotalHDD.Series2);
      FGraphTotalHDD.RealTimeAdd(FGraphTotalHDD.Series1, Usage);
      FGraphTotalHDD.DoScrollPoints(FGraphTotalHDD.Series1);
end;

procedure TForm1.CPUUsageEvent(CPUUsage: TCPUUsage);
var
   Lbl: TLabel;
   I : Integer;
   GrpahCPU : TFGraphMin;
begin
   Label_TotalCPU.Caption :=  'CPU : ' +  IntToStr(Trunc(CPUUsage.Total)){FloatToStrF(CPUUsage.Total,ffFixed, 3, 2)} + '%';
   for I := Low(CPUUsage.Cores) to High(CPUUsage.Cores) do
   begin
      GrpahCPU := FindComponent('FGraphCPU_' + IntToStr(I)) as TFGraphMin;
      GrpahCPU.RealTimeAdd2(GrpahCPU.Series2);
      GrpahCPU.DoScrollPoints(GrpahCPU.Series2);
      GrpahCPU.RealTimeAdd(GrpahCPU.Series1, CPUUsage.Cores[I].UsageCore);
      GrpahCPU.DoScrollPoints(GrpahCPU.Series1);
        // Lbl := FindComponent('LabelCpu'+IntToStr(i)) as TLabel;
        // lbl.Caption := 'CPU '  + IntToStr(I) + ' : ' + IntToStr(Trunc(CPUUsage.Cores[I].UsageCore)) + '%';
   end;
  FGraphTotalCPU.RealTimeAdd2(FGraphTotalCPU. Series2);
  FGraphTotalCPU.DoScrollPoints(FGraphTotalCPU.Series2);
  FGraphTotalCPU.RealTimeAdd(FGraphTotalCPU.Series1, CPUUsage.Total);
  FGraphTotalCPU.DoScrollPoints(FGraphTotalCPU.Series1);

     
end;

procedure TForm1.FormShow(Sender: TObject);
var
   I : Integer;
   NewLabel: TLabel;
   NewChart: TChart;
   NewSeries1: TFastLineSeries;
   NewSeries2: TFastLineSeries;
   GrpahCPU : TFGraphMin;
begin
      FGraphTotalCPU.Show;
      FGraphTotalHDD.Show;
      for I := 0 to CPUReport.CPUCount -1  do
      begin
          GrpahCPU := FindComponent('FGraphCPU_' + IntToStr(I)) as TFGraphMin;
          GrpahCPU.Show;
      end;
     {for I := 0 to CPUReport.CPUCount -1  do
     begin
       NewLabel := TLabel.Create(self);
       with NewLabel do
       begin
         Parent := Self;
         Name := 'LabelCpu'  + IntToStr(I);
         Caption := 'CPU '  + IntToStr(I) + ' : 0%' ;
         Left := 20;
         Top := ((I+1) * 20) + Label_TotalCPU.Top;
         Width := 257;
         Height := 19;
         Font.Charset := DEFAULT_CHARSET;
         Font.Color := clWindowText ;
         Font.Height := -16;
         Font.Name := 'Tahoma';
         Font.Style := [] ;
         ParentFont := False ;
       end;
       NewChart :=TChart.Create(Self);
     end; }
end;





procedure TForm1.FormCreate(Sender: TObject);
var
  I , N: Integer;
  FGraphCPU:  TFGraphMin ;
begin





{$if CompilerVersion > 20}
   FormatSettings.DecimalSeparator := '.';
{$else}
   DecimalSeparator := '.';
{$ifend}
   SMBios:=TSMBios.Create;
   if SMBios.HasProcessorInfo then
   for LProcessorInfo in SMBios.ProcessorInfo do
   begin
      Label_ProcName.Caption := 'CPU : ' + LProcessorInfo.ProcessorVersionStr;
      //Label_ProcSpeed.Caption := 'Max Speed : ' +  IntToStr(LProcessorInfo.RAWProcessorInformation^.MaxSpeed) + 'MHz';
      //Label_Cache.Caption := 'Cache : ';
      //if (LProcessorInfo.RAWProcessorInformation^.L1CacheHandle>0) and (LProcessorInfo.L2Chache<>nil)  then
      //   Label_Cache.Caption := Label_Cache.Caption + ' L1=' + IntToStr(LProcessorInfo.L1Chache.GetInstalledCacheSize) + 'KB';
      //if (LProcessorInfo.RAWProcessorInformation^.L2CacheHandle>0)  and (LProcessorInfo.L2Chache<>nil)  then
      //   Label_Cache.Caption := Label_Cache.Caption + ' L2=' + IntToStr(LProcessorInfo.L2Chache.GetInstalledCacheSize) + 'KB';
      // if (LProcessorInfo.RAWProcessorInformation^.L3CacheHandle>0) and (LProcessorInfo.L3Chache<>nil) then
      //   Label_Cache.Caption := Label_Cache.Caption + ' L3=' + IntToStr(LProcessorInfo.L2Chache.GetInstalledCacheSize) + 'KB';
   end;

   CPUReport := TCPUReport.Create(Self);

   CPUReport.onReport := CPUUsageEvent;


   HDDReport := THDDReport.Create(Self);
   HDDReport.onReport := HDDUsageEvent;


   FGraphTotalCPU := TFGraphMin.Create(self);
   FGraphTotalCPU.Parent := Panel_CPU;

   FGraphTotalCPU.Left := 20;
   FGraphTotalCPU.Top := 40;
   FGraphTotalCPU.Label_1.Caption := 'Utilization over 60 seconds';

   FGraphTotalHDD := TFGraphMin.Create(self);
   FGraphTotalHDD.Parent := Panel_HDD;

   FGraphTotalHDD.Left := 20;
   FGraphTotalHDD.Top := 40;
   FGraphTotalHDD.Label_1.Caption := 'Active time';

   for I := 0 to CPUReport.CPUCount -1  do
   begin
      FGraphCPU := TFGraphMin.Create(self);
      FGraphCPU.Name := 'FGraphCPU_' + IntToStr(I);
      FGraphCPU.Parent := Panel_CPU;
      FGraphCPU.Label_1.Caption := 'Core ' + IntToStr(I);
      FGraphCPU.Label2.Caption := '';
      if not Odd(I) then
      begin
         FGraphCPU.Left := 20;
         FGraphCPU.Top := FGraphTotalCPU.Height + 40 + ((FGraphCPU.Height div 2) * I);
      end
      else
      begin
        FGraphCPU.left := FGraphCPU.Width + 30;
        FGraphCPU.Top := FGraphTotalCPU.Height + 40 + ((FGraphCPU.Height div 2) * (I -1));
      end;

   end;

end;




procedure TForm1.Panel_BtnCPUClick(Sender: TObject);
begin
  Panel_BtnCPU.Color := $00d9d9d9;
  Panel_BtnHDD.Color := clWhite;
  Notebook1.ActivePage := 'PageCPU';
end;

procedure TForm1.Panel_BtnCPUMouseEnter(Sender: TObject);
begin
  if Panel_BtnCPU.Color <> $00d9d9d9 then
      Panel_BtnCPU.Color := $00EFE7CF;
end;

procedure TForm1.Panel_BtnCPUMouseLeave(Sender: TObject);
begin
if Panel_BtnCPU.Color <> $00d9d9d9 then
      Panel_BtnCPU.Color := clWhite;
end;

procedure TForm1.Panel_BtnHDDClick(Sender: TObject);
begin
   Panel_BtnHDD.Color := $00d9d9d9;
   Panel_BtnCPU.Color := clWhite;
   Notebook1.ActivePage := 'PageHDD';
end;

procedure TForm1.Panel_BtnHDDMouseEnter(Sender: TObject);
begin
  if Panel_BtnHDD.Color <> $00d9d9d9 then
      Panel_BtnHDD.Color := $00EFE7CF;
end;

procedure TForm1.Panel_BtnHDDMouseLeave(Sender: TObject);
begin
if Panel_BtnHDD.Color <> $00d9d9d9 then
      Panel_BtnHDD.Color := clWhite;
end;

end.
